package br.usp.ime.evolvinggraph;

public class Edge {
	Node u;
	Node v;
	Schedule schedule;
	Edge inv;
	int cost;
	
	public Edge(Node u, Node v, Schedule schedule, int cost) {
		this.u = u;
		this.v = v;
		this.schedule = schedule;
		this.cost = cost;
	}
	
	public Integer getNextDeparture(int time) {
		return schedule.nextTime(time);
	}
	
	public Interval getNextDepartureInterval(int time){
		Integer depart = getNextDeparture(time);
		if (depart == null) return null;
		Interval inter = schedule.getIntervalContaining(depart);
		return new Interval(depart, inter.end-1);
	}

	public Node getU() {
		return u;
	}

	public void setU(Node u) {
		this.u = u;
	}

	public Node getV() {
		return v;
	}

	public void setV(Node v) {
		this.v = v;
	}

	public int getCost() {
		return cost;
	}

	public void setCost(int cost) {
		this.cost = cost;
	}

	public Schedule getSchedule() {
		return schedule;
	}

	public Edge getInv() {
		return inv;
	}

	public void setInv(Edge inv) {
		this.inv = inv;
	}
	
	public String toString(){
		String str = u.getId() + "-" + v.getId() + " " + schedule;
		return str;
	}

	public int getNextEvent(int arrival) {
		return schedule.getNextEvent(arrival);
	}

	public Integer lastDepartureBefore(Integer endTime) {
		Integer departure; 
		endTime -= this.cost;
		departure = schedule.lastTime(endTime);
		return departure;
	}
	
}
