package br.usp.ime.evolvinggraph;

import java.util.ArrayList;
import java.util.LinkedList;

public class Node {
	int id;
	LinkedList<Edge> adj;
	LinkedList<Integer> nodeSchedule;

	public Node(int id) {
		this.id = id;
		this.adj = new LinkedList<Edge>();
		this.nodeSchedule = new LinkedList<Integer>();
	}
	
	public Edge add(Node v, Schedule sched, int cost){
		Edge e = new Edge(this, v,sched,cost);
		this.adj.add(e);
		return e;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public LinkedList<Edge> getAdj() {
		return adj;
	}

	public LinkedList<Integer> getNodeSchedule() {
		return nodeSchedule;
	}

	public void removeTime(Node v, int t) {
		ArrayList<Edge> toRemove = new ArrayList<Edge>();
		for (Edge edge : adj){
			Schedule s = edge.getSchedule();
			if (edge.getV() == v)
				s.remove(t, t+1);
			else 
				s.remove(t-1,t+2);
			if (s.isEmpty())
				toRemove.add(edge);
			
			Edge inv = edge.getInv();
			if (inv != null){
				s = inv.getSchedule();
				s.remove(t-1, t+2);
				if (s.isEmpty()){
					inv.getU().getAdj().remove(inv);
				}
			}
		}
		for (Edge edge : toRemove){
			adj.remove(edge);
		}
	}

	public int nextConnection(int arrival) {
		int conn = Integer.MAX_VALUE;
		for (Edge edge : adj){
			int dep = edge.getNextEvent(arrival);
			if (conn > dep)
				conn = dep;
		}
		return conn;
	}
}
